// test-tun.click

// This user-level configuration tests the KernelTun element, which
// accesses the Linux Universal Tun/Tap device, *BSD's /dev/tun* devices,
// or Linux's Ethertap devices (/dev/tap*).  These devices let user-level
// programs trade packets with kernel IP processing code.  You will need to
// run it as root.
//
// This configuration should work on FreeBSD, OpenBSD, and Linux.  It should
// produce a stream of 'tun-ok' printouts if all goes well.  On OpenBSD, you
// may need to run
//   route add 1.0.0.0 -interface 1.0.0.1
// after starting the Click configuration.  Also try running 'ping 1.0.0.2'
// (or any other host in 1.0.0.1/8) while the configuration is running.
// Click should respond to those pings.  It'll also print out 'tun-ping'
// messages for each ping received.

tun :: KernelTun(1.0.0.1/8);
tunq :: Queue -> tun;
tun[1] -> Print(tun-nonip) -> Discard;
ICMPPingSource(1.0.0.2, 1.0.0.1)
    -> tunq;

tun -> ch :: CheckIPHeader;

ch[0] -> IPPrint(tun-ok)
    -> IPFilter(allow icmp type echo)
       /* External pings only: KernelTun shouldn't emit packets that were
	  sent to it, so the ICMP echoes generated by ICMPPingSource won't
	  get this far. */
    -> ICMPPingResponder
    -> IPPrint(tun-ping)
    -> tunq;
ch[1] -> Print(tun-bad)
    -> Discard;
